<template>
    <div id=app>
      <label>Import Picross</label>
      <input type="button" value="Clic to import" @click="onClickImportPicross"/>
      <label>Listing des nonogrammes</label>
        <ul>
          <li
            v-for="(picross, index) in picrosslist"
            :key="'picross' + index"
            style="cursor: pointer"
            @click="selectPicross(picross)"
          >
            {{ picross.title }}
          </li>
        </ul>
        <picross-player
          v-if="selectedPicross"
          :picross-data="selectedPicross"
          @victory="displayVictory = true ; stopTimer()"
        />
        temps: {{currentTime}}
        <h1
          v-if="displayVictory"
        >
          Victoire en {{ currentTime}}!!!
    </h1>

      </div>
</template>
<script>

import PicrossPlayer from '@/components/PicrossPlayer.vue'
import VueRouter from 'vue-router'
const { isNavigationFailure, NavigationFailureType } = VueRouter

export default {
  name: 'Play',
  components: {
    PicrossPlayer
  },

  data: function () {
    return {
      selectedPicross: null,
      picrosslist: [],
      displayVictory: false,
      currentTime: 0

    }
  },
  mounted () {
    this.onClickImportPicross()
  },
  beforeRouteLeave (to, from, next) {
    this.stopTimer()
    next()
  },

  methods: {
    updatePicrossEditor () {
      this.numberRowsPicross = this.numberRows
      this.numberCellsPicross = this.numberCells
    },
    exportNonogram () {
      this.nonogramExported = {
        name: this.name,
        ...this.nonogramData
      }
    },
    selectPicross (picross) {
      this.stopTimer()
      this.selectedPicross = picross
      this.startTimer()
      this.$router.push({
        path: '/Play',
        query: { picross: picross.title }
      }).catch(failure => {
        if (!isNavigationFailure(failure, NavigationFailureType.duplicated)) {
          return failure
        }
      })
    },
    onClickImportPicross () {
      fetch('/picross.json')
        .then(res => res.json())
        .then(response => {
          this.picrosslist = response
          const picross = this.$route.query.picross
          const picrossFound = this.picrosslist.find(element => element.title === picross)
          if (picrossFound) { this.selectPicross(picrossFound) }
        })
    },
    resetTime () {
      this.currentTime = 0
    },
    startTimer () {
      this.stopTimer()
      this.resetTime()
      this.intervalId = setInterval(() => {
        this.currentTime++
      }, 1000)
    },
    stopTimer () {
      if (this.intervalId) clearInterval(this.intervalId)
    },
    route () {

    }
  }
}

</script>

<style>
      table {
        border: 1px solid gray;
        border-collapse: collapse;
      }
      tr, td {
        height: 20px;
      }
      td {
        width: 20px;
        border: 1px solid gray;
      }
      td:hover {
        background-color: red;
      }
      .selected {
        background-color: blue;
      }
</style>
